Index: /LMDZ5/trunk/libf/phylmd/radlwsw_m.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/radlwsw_m.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/radlwsw_m.F90	(revision 2146)
@@ -16,5 +16,6 @@
    flag_aerosol_strat,&
    tau_aero, piz_aero, cg_aero,&
-   tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,& ! rajoute par OB pour RRTM
+   tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,& ! rajoute par OB pour RRTM
+   tau_aero_lw_rrtm, &                                   ! rajoute par C. Kleinschmitt pour RRTM
    cldtaupi, new_aod, &
    qsat, flwc, fiwc, &
@@ -32,4 +33,9 @@
    solsw_aero, solsw0_aero, &
    topswcf_aero, solswcf_aero,&
+!-C. Kleinschmitt for LW diagnostics
+   toplwad_aero, sollwad_aero,&
+   toplwai_aero, sollwai_aero, &
+   toplwad0_aero, sollwad0_aero,&
+!-end
    ZLWFT0_i, ZFLDN0, ZFLUP0,&
    ZSWFT0_i, ZFSDN0, ZFSUP0)
@@ -51,5 +57,6 @@
 !     USE YOERAD   , ONLY : NSW      ,LRRTM    ,LCCNL    ,LCCNO ,&
 ! NSW mis dans .def MPL 20140211
-      USE YOERAD   , ONLY : LRRTM    ,LCCNL    ,LCCNO ,&
+! NLW ajoute par OB
+      USE YOERAD   , ONLY : NLW, LRRTM    ,LCCNL    ,LCCNO ,&
           NRADIP   , NRADLP , NICEOPT, NLIQOPT ,RCCNLND  , RCCNSEA
       USE YOELW    , ONLY : NSIL     ,NTRA     ,NUA      ,TSTAND   ,XP
@@ -67,4 +74,6 @@
       USE YOERRTWN , ONLY : DELWAVE   ,TOTPLNK      
       USE YOMPHY3  , ONLY : RII0
+#else
+      USE aero_mod, ONLY : nbands_lw_rrtm
 #endif
 
@@ -182,8 +191,17 @@
   REAL,    INTENT(in)  :: cg_aero(KLON,KLEV,9,2)                         ! aerosol optical properties (see aeropt.F)
 !--OB
-  REAL,    INTENT(in)  :: tau_aero_rrtm(KLON,KLEV,2,NSW)                 ! aerosol optical properties RRTM
-  REAL,    INTENT(in)  :: piz_aero_rrtm(KLON,KLEV,2,NSW)                 ! aerosol optical properties RRTM
-  REAL,    INTENT(in)  :: cg_aero_rrtm(KLON,KLEV,2,NSW)                  ! aerosol optical properties RRTM
+  REAL,    INTENT(in)  :: tau_aero_sw_rrtm(KLON,KLEV,2,NSW)                 ! aerosol optical properties RRTM
+  REAL,    INTENT(in)  :: piz_aero_sw_rrtm(KLON,KLEV,2,NSW)                 ! aerosol optical properties RRTM
+  REAL,    INTENT(in)  :: cg_aero_sw_rrtm(KLON,KLEV,2,NSW)                  ! aerosol optical properties RRTM
 !--OB fin
+
+!--C. Kleinschmitt
+#ifdef CPP_RRTM
+  REAL,    INTENT(in)  :: tau_aero_lw_rrtm(KLON,KLEV,2,NLW)                 ! LW aerosol optical properties RRTM
+#else
+  REAL,    INTENT(in)  :: tau_aero_lw_rrtm(KLON,KLEV,2,nbands_lw_rrtm)
+#endif
+!--C. Kleinschmitt end
+
   REAL,    INTENT(in)  :: cldtaupi(KLON,KLEV)                            ! cloud optical thickness for pre-industrial aerosol concentrations
   LOGICAL, INTENT(in)  :: new_aod                                        ! flag pour retrouver les resultats exacts de l'AR4 dans le cas ou l'on ne travaille qu'avec les sulfates
@@ -209,6 +227,10 @@
   REAL,    INTENT(out) :: topswad_aero(KLON), solswad_aero(KLON)         ! output: aerosol direct forcing at TOA and surface
   REAL,    INTENT(out) :: topswai_aero(KLON), solswai_aero(KLON)         ! output: aerosol indirect forcing atTOA and surface
+  REAL,    INTENT(out) :: toplwad_aero(KLON), sollwad_aero(KLON)         ! output: LW aerosol direct forcing at TOA and surface
+  REAL,    INTENT(out) :: toplwai_aero(KLON), sollwai_aero(KLON)         ! output: LW aerosol indirect forcing atTOA and surface
   REAL, DIMENSION(klon), INTENT(out)    :: topswad0_aero 
   REAL, DIMENSION(klon), INTENT(out)    :: solswad0_aero
+  REAL, DIMENSION(klon), INTENT(out)    :: toplwad0_aero 
+  REAL, DIMENSION(klon), INTENT(out)    :: sollwad0_aero
   REAL, DIMENSION(kdlon,9), INTENT(out) :: topsw_aero
   REAL, DIMENSION(kdlon,9), INTENT(out) :: topsw0_aero
@@ -271,4 +293,9 @@
   REAL(KIND=8) ztopswad0aero(kdlon), zsolswad0aero(kdlon)   ! Aerosol direct forcing at TOAand surface
   REAL(KIND=8) ztopswaiaero(kdlon), zsolswaiaero(kdlon)     ! dito, indirect
+!-LW by CK
+  REAL(KIND=8) ztoplwadaero(kdlon), zsollwadaero(kdlon)     ! LW Aerosol direct forcing at TOAand surface
+  REAL(KIND=8) ztoplwad0aero(kdlon), zsollwad0aero(kdlon)   ! LW Aerosol direct forcing at TOAand surface
+  REAL(KIND=8) ztoplwaiaero(kdlon), zsollwaiaero(kdlon)     ! dito, indirect
+!-end
   REAL(KIND=8) ztopsw_aero(kdlon,9), ztopsw0_aero(kdlon,9)
   REAL(KIND=8) zsolsw_aero(kdlon,9), zsolsw0_aero(kdlon,9)
@@ -316,4 +343,8 @@
       REAL(KIND=8) PCGA_NAT(klon,klev,NSW)
       REAL(KIND=8) PTAU_NAT(klon,klev,NSW)
+#ifdef CPP_RRTM
+      REAL(KIND=8) PTAU_LW_TOT(klon,klev,NLW)
+      REAL(KIND=8) PTAU_LW_NAT(klon,klev,NLW)
+#endif
       REAL(KIND=8) PSFSWDIR(klon,NSW)
       REAL(KIND=8) PSFSWDIF(klon,NSW)
@@ -644,11 +675,11 @@
       DO kk=1, NSW
 !
-      PTAU_TOT(i,kflev+1-k,kk)=tau_aero_rrtm(i,k,2,kk)
-      PPIZA_TOT(i,kflev+1-k,kk)=piz_aero_rrtm(i,k,2,kk)
-      PCGA_TOT(i,kflev+1-k,kk)=cg_aero_rrtm(i,k,2,kk)
-!
-      PTAU_NAT(i,kflev+1-k,kk)=tau_aero_rrtm(i,k,1,kk)
-      PPIZA_NAT(i,kflev+1-k,kk)=piz_aero_rrtm(i,k,1,kk)
-      PCGA_NAT(i,kflev+1-k,kk)=cg_aero_rrtm(i,k,1,kk)
+      PTAU_TOT(i,kflev+1-k,kk)=tau_aero_sw_rrtm(i,k,2,kk)
+      PPIZA_TOT(i,kflev+1-k,kk)=piz_aero_sw_rrtm(i,k,2,kk)
+      PCGA_TOT(i,kflev+1-k,kk)=cg_aero_sw_rrtm(i,k,2,kk)
+!
+      PTAU_NAT(i,kflev+1-k,kk)=tau_aero_sw_rrtm(i,k,1,kk)
+      PPIZA_NAT(i,kflev+1-k,kk)=piz_aero_sw_rrtm(i,k,1,kk)
+      PCGA_NAT(i,kflev+1-k,kk)=cg_aero_sw_rrtm(i,k,1,kk)
 !
       ENDDO
@@ -657,4 +688,19 @@
 !-end OB
 !
+!--C. Kleinschmitt
+!--aerosol TOT  - anthropogenic+natural
+!--aerosol NAT  - natural only
+!
+      DO i = 1, kdlon
+      DO k = 1, kflev
+      DO kk=1, NLW
+!
+      PTAU_LW_TOT(i,kflev+1-k,kk)=tau_aero_lw_rrtm(i,k,2,kk)
+      PTAU_LW_NAT(i,kflev+1-k,kk)=tau_aero_lw_rrtm(i,k,1,kk)
+!
+      ENDDO
+      ENDDO
+      ENDDO
+!-end C. Kleinschmitt
 !      
       DO i = 1, kdlon
@@ -761,4 +807,5 @@
          PPIZA_TOT, PCGA_TOT,PTAU_TOT,&
          PPIZA_NAT, PCGA_NAT,PTAU_NAT,           &  ! rajoute par OB pour diagnostiquer effet direct
+         PTAU_LW_TOT, PTAU_LW_NAT,               &  ! rajoute par C. Kleinschmitt
          ZFLUX_i  , ZFLUC_i ,&
          ZFSDWN_i , ZFSUP_i , ZFCDWN_i, ZFCUP_i,&
@@ -767,4 +814,7 @@
          ZTOPSWAIAERO,ZSOLSWAIAERO, &
          ZTOPSWCF_AERO,ZSOLSWCF_AERO, &
+         ZTOPLWADAERO,ZSOLLWADAERO,&  ! rajoute par C. Kleinscmitt pour LW diagnostics
+         ZTOPLWAD0AERO,ZSOLLWAD0AERO,&
+         ZTOPLWAIAERO,ZSOLLWAIAERO, &
          ok_ade, ok_aie, flag_aerosol,flag_aerosol_strat) ! flags aerosols
             
@@ -813,5 +863,7 @@
 !  PPIZA_NAT    (KPROMA,KLEV,NSW); Single scattering albedo of natural aerosols 
 !  PCGA_NAT     (KPROMA,KLEV,NSW); Assymetry factor for natural aerosols 
-!  PTAU_NAT     (KPROMA,KLEV,NSW); Optical depth of natiral aerosols 
+!  PTAU_NAT     (KPROMA,KLEV,NSW); Optical depth of natiral aerosols
+!  PTAU_LW_TOT  (KPROMA,KLEV,NLW); LW Optical depth of total aerosols  
+!  PTAU_LW_NAT  (KPROMA,KLEV,NLW); LW Optical depth of natural aerosols  
 !  PSFSWDIR     (KPROMA,NSW)     ;
 !  PSFSWDIF     (KPROMA,NSW)     ;
@@ -974,5 +1026,10 @@
           solsw0_aero(iof+i,:) = zsolsw0_aero(i,:)
           topswcf_aero(iof+i,:) = ztopswcf_aero(i,:)
-          solswcf_aero(iof+i,:) = zsolswcf_aero(i,:)          
+          solswcf_aero(iof+i,:) = zsolswcf_aero(i,:)   
+          !-LW
+          toplwad_aero(iof+i) = ztoplwadaero(i)
+          toplwad0_aero(iof+i) = ztoplwad0aero(i)
+          sollwad_aero(iof+i) = zsollwadaero(i)
+          sollwad0_aero(iof+i) = zsollwad0aero(i)    
         ENDDO
     ELSE
@@ -986,4 +1043,9 @@
           solsw_aero(iof+i,:) = 0.
           solsw0_aero(iof+i,:) = 0.
+          !-LW
+          toplwad_aero(iof+i) = 0.0
+          sollwad_aero(iof+i) = 0.0
+          toplwad0_aero(iof+i) = 0.0
+          sollwad0_aero(iof+i) = 0.0
         ENDDO
     ENDIF
@@ -992,4 +1054,7 @@
           topswai_aero(iof+i) = ztopswaiaero(i)
           solswai_aero(iof+i) = zsolswaiaero(i)
+          !-LW
+          toplwai_aero(iof+i) = ztoplwaiaero(i)
+          sollwai_aero(iof+i) = zsollwaiaero(i)
         ENDDO
     ELSE
@@ -997,4 +1062,7 @@
           topswai_aero(iof+i) = 0.0
           solswai_aero(iof+i) = 0.0
+          !-LW
+          toplwai_aero(iof+i) = 0.0
+          sollwai_aero(iof+i) = 0.0
         ENDDO
     ENDIF
Index: /LMDZ5/trunk/libf/phylmd/readaerosol_optic.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/readaerosol_optic.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/readaerosol_optic.F90	(revision 2146)
@@ -14,6 +14,6 @@
   USE dimphy
   USE aero_mod
-  USE phys_local_var_mod, only: sconcso4,sconcoa,sconcbc,sconcss,sconcdust, &
-      concso4,concoa,concbc,concss,concdust,loadso4,loadoa,loadbc,loadss,loaddust, &
+  USE phys_local_var_mod, only: sconcso4,sconcno3,sconcoa,sconcbc,sconcss,sconcdust, &
+      concso4,concno3,concoa,concbc,concss,concdust,loadso4,loadoa,loadbc,loadss,loaddust, &
       load_tmp1,load_tmp2,load_tmp3,load_tmp4,load_tmp5,load_tmp6,load_tmp7
   IMPLICIT NONE
@@ -82,5 +82,5 @@
        flag_aerosol .EQ. 6 ) THEN 
 
-     CALL readaerosol_interp(id_ASSO4M, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, sulfate, sulfate_pi,loadso4)
+     CALL readaerosol_interp(id_ASSO4M_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, sulfate, sulfate_pi,loadso4)
   ELSE
      sulfate(:,:) = 0. ; sulfate_pi(:,:) = 0.
@@ -93,6 +93,6 @@
 
      ! Get bc aerosol distribution 
-     CALL readaerosol_interp(id_ASBCM, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, bcsol, bcsol_pi, load_tmp1 )
-     CALL readaerosol_interp(id_AIBCM, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, bcins, bcins_pi, load_tmp2 )
+     CALL readaerosol_interp(id_ASBCM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, bcsol, bcsol_pi, load_tmp1 )
+     CALL readaerosol_interp(id_AIBCM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, bcins, bcins_pi, load_tmp2 )
      loadbc(:)=load_tmp1(:)+load_tmp2(:)
   ELSE
@@ -107,6 +107,6 @@
        flag_aerosol .EQ. 6 ) THEN
 
-     CALL readaerosol_interp(id_ASPOMM, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomsol, pomsol_pi, load_tmp3)
-     CALL readaerosol_interp(id_AIPOMM, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomins, pomins_pi, load_tmp4)
+     CALL readaerosol_interp(id_ASPOMM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomsol, pomsol_pi, load_tmp3)
+     CALL readaerosol_interp(id_AIPOMM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomins, pomins_pi, load_tmp4)
      loadoa(:)=load_tmp3(:)+load_tmp4(:)
   ELSE
@@ -121,7 +121,7 @@
       flag_aerosol .EQ. 6 ) THEN 
 
-      CALL readaerosol_interp(id_SSSSM ,itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, sssupco, sssupco_pi, load_tmp5) 
-      CALL readaerosol_interp(id_CSSSM ,itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, sscoarse,sscoarse_pi, load_tmp6) 
-      CALL readaerosol_interp(id_ASSSM ,itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, ssacu, ssacu_pi, load_tmp7) 
+      CALL readaerosol_interp(id_SSSSM_phy ,itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, sssupco, sssupco_pi, load_tmp5) 
+      CALL readaerosol_interp(id_CSSSM_phy ,itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, sscoarse,sscoarse_pi, load_tmp6) 
+      CALL readaerosol_interp(id_ASSSM_phy ,itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, ssacu, ssacu_pi, load_tmp7) 
      loadss(:)=load_tmp5(:)+load_tmp6(:)+load_tmp7(:)
   ELSE
@@ -136,5 +136,5 @@
       flag_aerosol .EQ. 6 ) THEN 
 
-      CALL readaerosol_interp(id_CIDUSTM, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, cidust, cidust_pi, loaddust) 
+      CALL readaerosol_interp(id_CIDUSTM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, cidust, cidust_pi, loaddust) 
 
   ELSE
@@ -146,14 +146,14 @@
 ! Store all aerosols in one variable
 !
-  m_allaer(:,:,id_ASBCM)  = bcsol(:,:)        ! ASBCM
-  m_allaer(:,:,id_ASPOMM) = pomsol(:,:)       ! ASPOMM
-  m_allaer(:,:,id_ASSO4M) = sulfate(:,:)      ! ASSO4M (= SO4) 
-  m_allaer(:,:,id_CSSO4M) = 0.                ! CSSO4M 
-  m_allaer(:,:,id_SSSSM)  = sssupco(:,:)      ! SSSSM
-  m_allaer(:,:,id_CSSSM)  = sscoarse(:,:)     ! CSSSM
-  m_allaer(:,:,id_ASSSM)  = ssacu(:,:)        ! ASSSM
-  m_allaer(:,:,id_CIDUSTM)= cidust(:,:)       ! CIDUSTM
-  m_allaer(:,:,id_AIBCM)  = bcins(:,:)        ! AIBCM
-  m_allaer(:,:,id_AIPOMM) = pomins(:,:)       ! AIPOMM
+  m_allaer(:,:,id_ASBCM_phy)  = bcsol(:,:)        ! ASBCM
+  m_allaer(:,:,id_ASPOMM_phy) = pomsol(:,:)       ! ASPOMM
+  m_allaer(:,:,id_ASSO4M_phy) = sulfate(:,:)      ! ASSO4M (= SO4) 
+  m_allaer(:,:,id_CSSO4M_phy) = 0.                ! CSSO4M 
+  m_allaer(:,:,id_SSSSM_phy)  = sssupco(:,:)      ! SSSSM
+  m_allaer(:,:,id_CSSSM_phy)  = sscoarse(:,:)     ! CSSSM
+  m_allaer(:,:,id_ASSSM_phy)  = ssacu(:,:)        ! ASSSM
+  m_allaer(:,:,id_CIDUSTM_phy)= cidust(:,:)       ! CIDUSTM
+  m_allaer(:,:,id_AIBCM_phy)  = bcins(:,:)        ! AIBCM
+  m_allaer(:,:,id_AIPOMM_phy) = pomins(:,:)       ! AIPOMM
 
 !RAF
@@ -207,5 +207,5 @@
 
      CALL aeropt(pplay, paprs, t_seri, sulfate, rhcl, &
-          tau_aero(:,:,id_ASSO4M,:), piz_aero(:,:,id_ASSO4M,:), cg_aero(:,:,id_ASSO4M,:), aerindex)
+          tau_aero(:,:,id_ASSO4M_phy,:), piz_aero(:,:,id_ASSO4M_phy,:), cg_aero(:,:,id_ASSO4M_phy,:), aerindex)
      
   END IF
@@ -213,14 +213,16 @@
 
 ! Diagnostics calculation for CMIP5 protocol
-  sconcso4(:)=m_allaer(:,1,id_ASSO4M)*1.e-9
-  sconcoa(:)=(m_allaer(:,1,id_ASPOMM)+m_allaer(:,1,id_AIPOMM))*1.e-9
-  sconcbc(:)=(m_allaer(:,1,id_ASBCM)+m_allaer(:,1,id_AIBCM))*1.e-9
-  sconcss(:)=(m_allaer(:,1,id_ASSSM)+m_allaer(:,1,id_CSSSM)+m_allaer(:,1,id_SSSSM))*1.e-9
-  sconcdust(:)=m_allaer(:,1,id_CIDUSTM)*1.e-9
-  concso4(:,:)=m_allaer(:,:,id_ASSO4M)*1.e-9
-  concoa(:,:)=(m_allaer(:,:,id_ASPOMM)+m_allaer(:,:,id_AIPOMM))*1.e-9
-  concbc(:,:)=(m_allaer(:,:,id_ASBCM)+m_allaer(:,:,id_AIBCM))*1.e-9
-  concss(:,:)=(m_allaer(:,:,id_ASSSM)+m_allaer(:,:,id_CSSSM)+m_allaer(:,:,id_SSSSM))*1.e-9
-  concdust(:,:)=m_allaer(:,:,id_CIDUSTM)*1.e-9
+  sconcso4(:)=m_allaer(:,1,id_ASSO4M_phy)*1.e-9
+!  sconcno3(:)=m_allaer(:,1,id_ASNO3M_phy)*1.e-9
+  sconcoa(:)=(m_allaer(:,1,id_ASPOMM_phy)+m_allaer(:,1,id_AIPOMM_phy))*1.e-9
+  sconcbc(:)=(m_allaer(:,1,id_ASBCM_phy)+m_allaer(:,1,id_AIBCM_phy))*1.e-9
+  sconcss(:)=(m_allaer(:,1,id_ASSSM_phy)+m_allaer(:,1,id_CSSSM_phy)+m_allaer(:,1,id_SSSSM_phy))*1.e-9
+  sconcdust(:)=m_allaer(:,1,id_CIDUSTM_phy)*1.e-9
+  concso4(:,:)=m_allaer(:,:,id_ASSO4M_phy)*1.e-9
+!  concno3(:,:)=m_allaer(:,:,id_ASNO3M_phy)*1.e-9
+  concoa(:,:)=(m_allaer(:,:,id_ASPOMM_phy)+m_allaer(:,:,id_AIPOMM_phy))*1.e-9
+  concbc(:,:)=(m_allaer(:,:,id_ASBCM_phy)+m_allaer(:,:,id_AIBCM_phy))*1.e-9
+  concss(:,:)=(m_allaer(:,:,id_ASSSM_phy)+m_allaer(:,:,id_CSSSM_phy)+m_allaer(:,:,id_SSSSM_phy))*1.e-9
+  concdust(:,:)=m_allaer(:,:,id_CIDUSTM_phy)*1.e-9
 
 
Index: /LMDZ5/trunk/libf/phylmd/readaerosolstrato.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/readaerosolstrato.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/readaerosolstrato.F90	(revision 2146)
@@ -142,9 +142,8 @@
     ENDIF !--debut ou nouveau mois
 
-!--total vertical aod at the 5 wavelengths
+!--total vertical aod at the 6 wavelengths
     DO wave=1, nwave
     DO k=1, klev
-    tausum_aero(:,wave,id_STRAT)=tausum_aero(:,wave,id_STRAT)+tau_aer_strat(:,k)*alpha_strat_wave(wave)/alpha_strat_wave(2)
-!    tausum_aero(:,wave,id_ASBCM)=tausum_aero(:,wave,id_ASBCM)+tau_aer_strat(:,k)*alpha_strat_wave(wave)/alpha_strat_wave(2)
+    tausum_aero(:,wave,id_STRAT_phy)=tausum_aero(:,wave,id_STRAT_phy)+tau_aer_strat(:,k)*alpha_strat_wave(wave)/alpha_strat_wave(2)
     ENDDO
     ENDDO
Index: /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90	(revision 2146)
@@ -12,5 +12,4 @@
   USE aero_mod
   USE phys_local_var_mod, only: od550aer,od865aer,ec550aer,od550lt1aer
-  USE YOMCST           , only : RD , RG
 
   !
@@ -50,4 +49,5 @@
   !
   IMPLICIT NONE
+  INCLUDE "YOMCST.h"
   !
   ! Input arguments:
@@ -55,5 +55,5 @@
   REAL, DIMENSION(klon,klev), INTENT(in)   :: pdel
   REAL, INTENT(in)                         :: delt
-  REAL, DIMENSION(klon,klev,naero_spc), INTENT(in) :: m_allaer
+  REAL, DIMENSION(klon,klev,naero_tot), INTENT(in) :: m_allaer
   REAL, DIMENSION(klon,klev), INTENT(in)   :: RHcl     ! humidite relative ciel clair
   INTEGER,INTENT(in)                       :: flag_aerosol
@@ -73,5 +73,5 @@
   LOGICAL :: soluble
   
-  INTEGER :: i, k, m
+  INTEGER :: i, k, m, aerindex
   INTEGER :: spsol, spinsol, la
   INTEGER :: RH_num(klon,klev)
@@ -96,5 +96,6 @@
   REAL :: zdp1(klon,klev) 
   INTEGER, ALLOCATABLE, DIMENSION(:)  :: aerosol_name
-  INTEGER :: nb_aer
+  INTEGER :: nb_aer, itau
+  LOGICAL :: ok_itau
   
   REAL :: dh(KLON,KLEV)
@@ -105,5 +106,5 @@
   REAL :: alpha_aeri_5wv(las,naero_insoluble)         ! Ext. coeff. ** m2/g 
 
-  REAL, DIMENSION(klon,klev,naero_spc) :: mass_temp
+  REAL, DIMENSION(klon,klev,naero_tot) :: mass_temp
   
   !
@@ -113,5 +114,5 @@
   LOGICAL :: used_tau(naero_tot)
   INTEGER :: n
-  
+
 ! From here on we look at the optical parameters at 5 wavelengths:  
 ! 443nm, 550, 670, 765 and 865 nm 
@@ -222,39 +223,39 @@
      nb_aer = 2
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_ASSO4M
-     aerosol_name(2) = id_CSSO4M
+     aerosol_name(1) = id_ASSO4M_phy
+     aerosol_name(2) = id_CSSO4M_phy
   ELSEIF (flag_aerosol .EQ. 2) THEN
      nb_aer = 2
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_ASBCM
-     aerosol_name(2) = id_AIBCM
+     aerosol_name(1) = id_ASBCM_phy
+     aerosol_name(2) = id_AIBCM_phy
   ELSEIF (flag_aerosol .EQ. 3) THEN 
      nb_aer = 2
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_ASPOMM
-     aerosol_name(2) = id_AIPOMM
+     aerosol_name(1) = id_ASPOMM_phy
+     aerosol_name(2) = id_AIPOMM_phy
   ELSEIF (flag_aerosol .EQ. 4) THEN 
      nb_aer = 3
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_CSSSM
-     aerosol_name(2) = id_SSSSM
-     aerosol_name(3) = id_ASSSM
+     aerosol_name(1) = id_CSSSM_phy
+     aerosol_name(2) = id_SSSSM_phy
+     aerosol_name(3) = id_ASSSM_phy
   ELSEIF (flag_aerosol .EQ. 5) THEN 
      nb_aer = 1
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_CIDUSTM
+     aerosol_name(1) = id_CIDUSTM_phy
   ELSEIF (flag_aerosol .EQ. 6) THEN 
      nb_aer = 10
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_ASSO4M      
-     aerosol_name(2) = id_ASBCM
-     aerosol_name(3) = id_AIBCM
-     aerosol_name(4) = id_ASPOMM
-     aerosol_name(5) = id_AIPOMM
-     aerosol_name(6) = id_CSSSM
-     aerosol_name(7) = id_SSSSM
-     aerosol_name(8) = id_ASSSM
-     aerosol_name(9) = id_CIDUSTM
-     aerosol_name(10) = id_CSSO4M
+     aerosol_name(1) = id_ASSO4M_phy      
+     aerosol_name(2) = id_ASBCM_phy
+     aerosol_name(3) = id_AIBCM_phy
+     aerosol_name(4) = id_ASPOMM_phy
+     aerosol_name(5) = id_AIPOMM_phy
+     aerosol_name(6) = id_CSSSM_phy
+     aerosol_name(7) = id_SSSSM_phy
+     aerosol_name(8) = id_ASSSM_phy
+     aerosol_name(9) = id_CIDUSTM_phy
+     aerosol_name(10) = id_CSSO4M_phy
   ENDIF
 
@@ -293,34 +294,34 @@
   DO m=1,nb_aer   ! tau is only computed for each mass    
     fac=1.0
-    IF (aerosol_name(m).EQ.id_ASBCM) THEN
+    IF (aerosol_name(m).EQ.id_ASBCM_phy) THEN
         soluble=.TRUE.
         spsol=1
-    ELSEIF (aerosol_name(m).EQ.id_ASPOMM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_ASPOMM_phy) THEN 
         soluble=.TRUE.
         spsol=2 
-    ELSEIF (aerosol_name(m).EQ.id_ASSO4M) THEN
+    ELSEIF (aerosol_name(m).EQ.id_ASSO4M_phy) THEN
         soluble=.TRUE.
         spsol=3
         fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for OD
-    ELSEIF (aerosol_name(m).EQ.id_CSSO4M) THEN
+    ELSEIF (aerosol_name(m).EQ.id_CSSO4M_phy) THEN
         soluble=.TRUE.
         spsol=4
         fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for OD
-    ELSEIF (aerosol_name(m).EQ.id_SSSSM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_SSSSM_phy) THEN 
         soluble=.TRUE.
         spsol=5
-    ELSEIF (aerosol_name(m).EQ.id_CSSSM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_CSSSM_phy) THEN 
         soluble=.TRUE.
         spsol=6
-    ELSEIF (aerosol_name(m).EQ.id_ASSSM) THEN
+    ELSEIF (aerosol_name(m).EQ.id_ASSSM_phy) THEN
         soluble=.TRUE.
         spsol=7
-    ELSEIF (aerosol_name(m).EQ.id_CIDUSTM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_CIDUSTM_phy) THEN 
         soluble=.FALSE.
         spinsol=1
-    ELSEIF  (aerosol_name(m).EQ.id_AIBCM) THEN 
+    ELSEIF  (aerosol_name(m).EQ.id_AIBCM_phy) THEN 
         soluble=.FALSE.
         spinsol=2
-    ELSEIF (aerosol_name(m).EQ.id_AIPOMM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_AIPOMM_phy) THEN 
         soluble=.FALSE.
         spinsol=3
@@ -335,4 +336,6 @@
     ENDIF
 
+    aerindex=aerosol_name(m)
+
     DO la=1,las
 
@@ -344,10 +347,10 @@
                              (alpha_aers_5wv(RH_num(i,k)+1,la,spsol) - & 
                               alpha_aers_5wv(RH_num(i,k),la,spsol))
-              tau(i,k,la,spsol) = mass_temp(i,k,spsol)*1000.*zdp1(i,k)   &
-                                 *tau_ae5wv_int*delt*fac
-              tausum(i,la,spsol)=tausum(i,la,spsol)+tau(i,k,la,spsol)
+              tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)*   &
+                                    tau_ae5wv_int*delt*fac
+              tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
             ENDDO
           ENDDO
-
+ 
       ELSE                         ! For insoluble aerosol
 
@@ -355,8 +358,7 @@
           DO i=1, KLON
             tau_ae5wv_int = alpha_aeri_5wv(la,spinsol)
-            tau(i,k,la,naero_soluble+spinsol) = mass_temp(i,k,naero_soluble+spinsol)*1000.*zdp1(i,k)* &
-                                                tau_ae5wv_int*delt*fac
-            tausum(i,la,naero_soluble+spinsol)= tausum(i,la,naero_soluble+spinsol)  &
-                                               +tau(i,k,la,naero_soluble+spinsol)
+            tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)* &
+                                   tau_ae5wv_int*delt*fac
+            tausum(i,la,aerindex)= tausum(i,la,aerindex)+tau(i,k,la,aerindex)
           ENDDO
         ENDDO
@@ -405,7 +407,7 @@
   ENDDO
 
-  od550lt1aer(:)=tausum(:,la550,id_ASSO4M)+tausum(:,la550,id_ASBCM) +tausum(:,la550,id_AIBCM)+ &
-                 tausum(:,la550,id_ASPOMM)+tausum(:,la550,id_AIPOMM)+tausum(:,la550,id_ASSSM)+ &
-                 0.03*tausum(:,la550,id_CSSSM)+0.4*tausum(:,la550,id_CIDUSTM)
+  od550lt1aer(:)=tausum(:,la550,id_ASSO4M_phy)+tausum(:,la550,id_ASBCM_phy) +tausum(:,la550,id_AIBCM_phy)+ &
+                 tausum(:,la550,id_ASPOMM_phy)+tausum(:,la550,id_AIPOMM_phy)+tausum(:,la550,id_ASSSM_phy)+ &
+                 0.03*tausum(:,la550,id_CSSSM_phy)+0.4*tausum(:,la550,id_CIDUSTM_phy)
 
   DEALLOCATE(aerosol_name) 
